/*

*/
#include <stdio.h>
#include <omp.h>

int doWork(int n)
{
   int i;
   int tid = omp_get_thread_num();
   printf("doWork() getting ready to work with thread %d.\n", tid);

   #pragma omp for    // try adding the keyword "parallel"
   for (i = 0; i < n; i++)
      printf("i = %d, tid = %d\n", i, omp_get_thread_num());

   return tid;
}


int main(int argc, char** argv)
{
   int result = 0;

   result = doWork(1);

   printf("The result = %d\n", result);

   #pragma omp parallel num_threads(4)
   result = doWork(12);

   printf("The result = %d\n", result);

   return 0;
}